# Out of Context - Context-free navigation & scaffolds

[![Travis CI](https://img.shields.io/travis/forus-labs/cauldron/master?logo=travis)](https://travis-ci.com/forus-labs/cauldron)
[![Codecov](https://codecov.io/gh/forus-labs/cauldron/branch/master/graph/badge.svg)](https://codecov.io/gh/forus-labs/cauldron)
[![Pub Dev](https://img.shields.io/pub/v/out_of_context)](https://pub.dev/packages/out_of_context)
[![Documentation](https://img.shields.io/badge/documentation-1.0.1-brightgreen.svg)](https://pub.dev/documentation/out_of_context/latest/)

Navigation in Flutter involves a great deal of ceremony as a `BuilderContext` must always be passed to a `Navigator`.
A `BuilContext` must be passed down from a Widget to the calling method, which is needlessly verbose. It also makes testing
hard as the navigation methods are static and cannot be mocked.

Out of Context provides (over-glorified) wrappers for context-free navigation and scaffolds.

**Please view the [stable brunch](https://github.com/forus-labs/cauldron/tree/stable/out_of_context/) for a production version.**

***
### Using `out_of_context`

To import the library, add the following dependency to your project.

```yaml
dependencies:
  out_of_context: ^1.0.1
```

Then, use any of the `Mixin`s provided.
```dart
import 'package:out_of_context/out_of_context.dart';

class Fancy with RouterMixin {

  // router is provided by the RouterMixin
  // Look Ma, no BuildContexts!
  void back() => router.pop();

}
```

***
###  Mock of Context

Mock of Context is a companion project that provides mocks to simplify testing. 

**Please see the project [here](https://pub.dev/packages/mock_of_context).**
